//*******************************************************
//
//	SM9501A + 7SEG LED dgv
//
//	MCU:ATmega168
//		efuse:0xF9
//		hfuse:0xD6	BOD 1.8V EEPROMی
//		lfuse:0xE2	CRU 8MHz
//
//	Compiler:	AVR-GCC		4.2.2
//				AVR-LIBC	1.4.7
//				binutils	2.18
//
//	2008.6.21	KAWAKAMI Yukio
//
//	New BSD license
//*******************************************************

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;
typedef unsigned short	ushort;

#define	SEG_DATA	PORTB

#define	LED_AM		0x01
#define	LED_PM		0x10
#define	LED_C1		0x02
#define	LED_C2		0x20
#define	LED_JJY		0x40

#define	COM5		7	// PORTD
#define	COM4		6
#define	COM3		5
#define	COM2		4
#define	COM1		3
#define	SW1_PORT	2
#define	TXD			1
#define	RXD			0

#define	SCL			5	// PORTC
#define	SDA			4
#define	PON			3
#define	FCN			2
#define	DATA		1
#define	SW2_PORT	0

#define		SW1		1
#define		SW2		2

#define		JJY_ON		(!(PINC & (1<<DATA)))
#define		JJY_ENABLE	(DDRC |= (1<<PON))
#define		JJY_DISABLE	(DDRC &= ~(1<<PON))
#define		CHECK_SW1	(!(PIND & (1<<SW1_PORT)))
#define		CHECK_SW2	(!(PINC & (1<<SW2_PORT)))
#define		FCN_40kHz	(DDRC |= (1<<FCN))
#define		FCN_60kHz	(DDRC &= ~(1<<FCN))

struct RTC_TIME {
	uchar	year;
	uchar	month;
	uchar	week;
	uchar	day;
	uchar	hour;
	uchar	min;
	uchar	sec;
};


#define		EEPROM_JJY60		(uint8_t *)1
#define		EEPROM_TIME12		(uint8_t *)2
#define		EEPROM_DUTY			(uint8_t *)3
#define		EEPROM_BAUD			(uint8_t *)4
#define		EEPROM_ALARM_HOUR	(uint8_t *)5
#define		EEPROM_ALARM_MIN	(uint8_t *)6
#define		EEPROM_ALARM_FLAG	(uint8_t *)7

uchar JJY_adjusting(void);

void menu(void);
void set_time(void);
uchar inkey(void);
void flash(void);
uchar set_digit(uchar n, uchar keta, uchar min, uchar max);
void set_alarm(void);

void set_hour(uchar hour);

void read_RTC(struct RTC_TIME *rtc);
uchar read_RTC_sec(void);
void adjust_RTC(struct RTC_TIME *rtc);

void next_min(struct RTC_TIME *rtc);
void JJY2RTC(struct RTC_TIME *rtc);
uchar BIN(uchar bcd);
uchar BCD(uchar bin);
uchar add_BCD(uchar source, uchar add);

void set_duty(uchar duty);
void alarm_on(void);
void alarm_off(void);

char	TWI_open(void);
char	TWI_start(void);
char	TWI_write(uchar data);
uchar	TWI_read_ack(void);
uchar	TWI_read_nack(void);
void	TWI_close(void);
